'use strict';

var CronogramaPeriodoController = angular.module('CronogramaPeriodoController', []);

CronogramaPeriodoController.controller('CronogramaPeriodoCtrl', ['$scope', '$filter', 'Construcao', 'CacheApp',
  ($scope, $filter, Construcao, CacheApp) => {
      $scope.construcao = {};

      $scope.construcao = CacheApp.getConstrucao();
      $scope.dataInicio = new Date($scope.construcao.DataInicio);
      $scope.dataFim = new Date($scope.construcao.DataFim);

      $scope.relatorio = {};
      $scope.relatorio.DataInicio = CacheApp.getData($scope.construcao.DataInicio ? $filter("date")($scope.construcao.DataInicio, 'yyyy-MM-ddT03:05:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT03:05:00Z'));
      $scope.relatorio.DataFim = CacheApp.getData($scope.construcao.DataFim ? $filter("date")($scope.construcao.DataFim, 'yyyy-MM-ddT03:05:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT03:05:00Z'));
  

      var tempoRestante = Math.abs($scope.dataFim - $scope.dataInicio);
      $scope.dias = Math.ceil(tempoRestante / (1000 * 3600 * 24));

      $scope.getListaDias = () => {
        $scope.listaDias = [];
        for (var i=0;i<$scope.dias-1;i++) {
            var dia = new Date($scope.construcao.DataInicio);
            dia.setDate(dia.getDate() + i);
            $scope.listaDias.push(dia);
        }
      }


      $scope.getPlanejaEtapa = () => {

        $scope.getListaDias();
        $scope.TotalMedicao = 0;
        $scope.construcao.ValorTotalizadoOrcamento = ($scope.construcao.ValorBDIEncargos == 0
                                                   || $scope.construcao.ValorBDIEncargos == null
                                                   || $scope.construcao.ValorBDIEncargos == undefined)
                                                    ? $scope.construcao.ValorOrcado
                                                    : $scope.construcao.ValorBDIEncargos;

        Construcao.getPlanejaEtapa($scope.construcao.Id,
            (data) => {
                $scope.etapas = data.Instance;
                $scope.Medicoes = [];

                for (var i in $scope.etapas) {
                    var etapa = $scope.etapas[i];
                    var id = etapa.IdEtapa;

                    etapa.QtdDiasInicio = etapa.QtdDiasInicio ? etapa.QtdDiasInicio : 0;;
                    var ini = etapa.QtdDiasInicio;

                    etapa.QtdDiasExecucao = etapa.QtdDiasExecucao ? etapa.QtdDiasExecucao : 0;
                    var fim = etapa.QtdDiasInicio + etapa.QtdDiasExecucao;

                    etapa.DataInicio = new Date($scope.construcao.DataInicio);
                    etapa.DataInicio.setDate(etapa.DataInicio.getDate() + ini);

                    etapa.DataFim = new Date($scope.construcao.DataInicio);
                    etapa.DataFim.setDate(etapa.DataFim.getDate() + fim);

                    for (var j in etapa.Medicoes) {
                        var sliderID = etapa.IdEtapa.toString() + j.toString();
                        var medicao = etapa.Medicoes[j];
                        medicao.SliderID = sliderID;

                        var ini = medicao.QtdDiasInicio;
                        var fim = medicao.QtdDiasInicio + medicao.QtdDiasExecucao;

                        medicao.DataInicio = new Date($scope.construcao.DataInicio);
                        medicao.DataInicio.setDate(medicao.DataInicio.getDate() + ini);
                        medicao.DataFim = new Date($scope.construcao.DataInicio);
                        medicao.DataFim.setDate(medicao.DataFim.getDate() + fim);

                        if ($scope.TotalMedicao < medicao.Medicao)
                            $scope.TotalMedicao = medicao.Medicao;
                    }

                }

                for (var i=1; i<=$scope.TotalMedicao; i++)
                    $scope.Medicoes.push({Medicao: i, Valor: 0});


                for (var i in $scope.etapas) {
                    var etapa = $scope.etapas[i];
                    for (var j in etapa.Medicoes) {
                        var medicao = etapa.Medicoes[j];
                        $scope.Medicoes[medicao.Medicao - 1].Valor += medicao.Valor;
                    }
                }

                $scope.etapasAll = $scope.etapas;
        });
    }
    $scope.getPlanejaEtapa();

    $scope.filterByDate = () => {
        $scope.filteredEtapas = []
        $scope.etapasAll.filter(e => 
            (e.Medicoes && e.Medicoes.length > 0) &&
            (
                ($scope.relatorio.DataInicio >= e.DataInicio && $scope.relatorio.DataInicio <= e.DataFim)
                || ($scope.relatorio.DataFim >= e.DataInicio && $scope.relatorio.DataFim <= e.DataFim)
            )
        ).forEach(e => {
            var etapa = {
                Etapa: e.Etapa,
                IdEtapa: e.IdEtapa,
                Ordem: e.Ordem,
                NomeEtapa: e.NomeEtapa,
                DataInicio: e.DataInicio,
                DataFim: e.DataFim,
                QtdDiasInicio: e.QtdDiasInicio,
                QtdDiasExecucao: e.QtdDiasExecucao,
                Valor: parseFloat(e.Valor),
                Medicoes: []
            }

            e.Medicoes.forEach(m => {
                etapa.Medicoes.push({
                    IdMedicao: m.IdMedicao,
                    Medicao: m.Medicao,
                    QtdDiasInicio: m.QtdDiasInicio,
                    QtdDiasExecucao: m.QtdDiasExecucao,
                    Valor: parseFloat(m.Valor),
                    Percentual: m.Percentual,
                    DataInicio: m.DataInicio,
                    DataFim: m.DataFim
                })
            })
            $scope.filteredEtapas.push(etapa)
        })

        $scope.filteredEtapas.forEach(etapa => {
            etapa.Medicoes.forEach(m => {
                var qtdDiasExec = Math.ceil(Math.abs(
                    ($scope.relatorio.DataFim < m.DataFim ? $scope.relatorio.DataFim : m.DataFim ) -
                    ($scope.relatorio.DataInicio > m.DataInicio ? $scope.relatorio.DataInicio : m.DataInicio  )
                ) / (1000 * 3600 * 24))

                if (qtdDiasExec == 0)
                    qtdDiasExec = 1


                if (qtdDiasExec != m.QtdDiasExecucao) {
                    m.Percentual = ( m.Percentual * (qtdDiasExec < m.QtdDiasExecucao ? (qtdDiasExec / m.QtdDiasExecucao) : (m.QtdDiasExecucao / qtdDiasExec)) ).toFixed(2)
                    m.Valor = (m.Valor * ((qtdDiasExec < m.QtdDiasExecucao ? (qtdDiasExec / m.QtdDiasExecucao) : (m.QtdDiasExecucao / qtdDiasExec)))).toFixed(2)
                    m.QtdDiasExecucao = qtdDiasExec-1
                }
            })
        })

        $scope.etapas = $scope.filteredEtapas

        $scope.Medicoes = [];
        $scope.TotalMedicaoPeriodo = 0;
        for (var i=1; i<=$scope.TotalMedicao; i++)
            $scope.Medicoes.push({Medicao: i, Valor: 0});


        $scope.etapas.forEach(etapa => {
            etapa.Valor = 0;
            etapa.Medicoes.forEach(medicao => {
                $scope.Medicoes[medicao.Medicao - 1].Valor += medicao.Valor
                etapa.Valor += medicao.Valor
            })
            $scope.TotalMedicaoPeriodo += etapa.Valor;
        })

        // for (var i in $scope.etapas) {
        //     var etapa = $scope.etapas[i];
        //     for (var j in etapa.Medicoes) {
        //         var medicao = etapa.Medicoes[j];
        //         $scope.Medicoes[medicao.Medicao - 1].Valor += medicao.Valor;
        //     }
        // }

        // $scope.$apply()
        // console.log($scope.filteredMedicoes);
    }

  }]);
